#include 	<jni.h>
#include	<stdlib.h>
#include 	<android/log.h>
#include	<sys/syscall.h>
#define LOG_TAG "CPUCORE"


#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

JNIEXPORT int JNICALL Java_aexp_samplerecognizer_CpuCore_getCurrentCore(JNIEnv* env, jobject thiz){
	unsigned cpu;
	if (syscall(__NR_getcpu, &cpu, NULL, NULL) < 0) {
        	return -1;
    	} else {
        	return (int) cpu;
    	}
}

inline int signalCost( int x1, int x2 ) {
	return abs( x1-x2 );
}

JNIEXPORT void JNICALL Java_aexp_samplerecognizer_MainActivity_processNative( 
			JNIEnv* env,
			jobject thiz,
			jshortArray signal1,
			jshortArray signal2,
			jintArray d0,
			jintArray d1,
			jintArray d2,
			jint minnm,
			jint maxnm,
			jint totalDiags ) {
	jshort *signal1ptr = (*env)->GetShortArrayElements( env,signal1, NULL);
	jshort *signal2ptr = (*env)->GetShortArrayElements( env,signal2, NULL);
	jint *d0ptr_init = (*env)->GetIntArrayElements( env,d0, NULL);
	jint *d1ptr_init = (*env)->GetIntArrayElements( env,d1, NULL);
	jint *d2ptr_init = (*env)->GetIntArrayElements( env,d2, NULL);

	int k,diagNo;
	jint *d0ptr = d0ptr_init;
	jint *d1ptr = d1ptr_init;
	jint *d2ptr = d2ptr_init;
	for( diagNo = 2 ; diagNo < totalDiags -2 ; ++diagNo ) {
//    		__android_log_print(
//			ANDROID_LOG_ERROR,
//			LOG_TAG, 
//			"processNativeSlow4, diagNo: %d",diagNo);
		int diagLen = 0;
		if( diagNo < minnm )
			diagLen = diagNo+1;
		else
		if( diagNo < maxnm )
			diagLen = minnm;
		else
			diagLen = totalDiags - diagNo;

// Starting X position of the diag is
// diag# if diag# < maxnm
// maxnm-1 if diag# >= maxmn
		int diagX = diagNo >= maxnm ? maxnm - 1 : diagNo;
// Starting Y position of the diag is
// 0 if diag# < maxnm
// diag# - maxnm + 1 if diag# >= maxnm
		int diagY = diagNo < maxnm ? 0 : diagNo - maxnm + 1;
		int k;
		int diagLenM1 = diagLen - 1;
		if( diagNo < maxnm ) {
			if( diagNo < minnm ) {
				d2ptr[diagLenM1] = d1ptr[diagNo-1] + 
					signalCost((jint)signal1ptr[0],(jint)signal2ptr[diagNo]);
			}
			d2ptr[0] = d1ptr[0] + 
				signalCost((jint)signal1ptr[diagNo],(jint)signal2ptr[0]);
			for( k = 1 ; k < diagLenM1 ; ++k ) {
				jint sum = 0;
				jint s1 = (jint)signal1ptr[diagX-k];
				jint s2 = (jint)signal2ptr[diagY+k];
				jint cs = signalCost( s1,s2);
				sum = 
				MIN( 
					d0ptr[k-1],
					d1ptr[k-1] );
				sum = MIN( sum, d1ptr[k] );
				sum += cs;
				d2ptr[k] = sum;
			}
		} else 
		if( diagNo == maxnm ) {
			for( k = 0 ; k < diagLen ; ++k ) {
				jint sum = 0;
				jint s1 = signal1ptr[diagX-k];
				jint s2 = signal2ptr[diagY+k];
				jint cs = signalCost( s1,s2);
				sum = 
					MIN( 
					d0ptr[k],
					d1ptr[k] );
				sum = MIN( sum, d1ptr[k+1] );
				sum += cs;
				d2ptr[k] = sum;
			}
		} else 
		if( diagNo > maxnm ) {
			for( k = 0 ; k < diagLen ; ++k ) {
				jint sum = 0;
				jint s1 = signal1ptr[diagX-k];
				jint s2 = signal2ptr[diagY+k];
				jint cs = signalCost( s1,s2);
				sum = 
				MIN( 
					d0ptr[k+1],
					d1ptr[k] );
				sum = MIN( sum, d1ptr[k+1] );
				sum += cs;
				d2ptr[k] = sum;
			}
		}
		jint *tmp = d0ptr;
		d0ptr = d1ptr;
		d1ptr = d2ptr;
		d2ptr = tmp;
	}
	(*env)->ReleaseIntArrayElements( env,d0,d0ptr, 0);
	(*env)->ReleaseIntArrayElements( env,d1,d1ptr, 0);
	(*env)->ReleaseIntArrayElements( env,d2,d2ptr, 0);
	(*env)->ReleaseShortArrayElements( env,signal1,signal1ptr, 0);
	(*env)->ReleaseShortArrayElements( env,signal2,signal2ptr, 0);
}

JNIEXPORT void JNICALL Java_aexp_samplerecognizer_MainActivity_processNativeSlow( 
			JNIEnv* env,
			jobject thiz,
			jshortArray signal1,
			jshortArray signal2,
			jintArray d0,
			jintArray d1,
			jintArray d2,
			jint minnm,
			jint maxnm,
			jint totalDiags ) {
	jshort *signal1ptr = (*env)->GetShortArrayElements( env,signal1, NULL);
	jshort *signal2ptr = (*env)->GetShortArrayElements( env,signal2, NULL);
	jint *d0ptr_init = (*env)->GetIntArrayElements( env,d0, NULL);
	jint *d1ptr_init = (*env)->GetIntArrayElements( env,d1, NULL);
	jint *d2ptr_init = (*env)->GetIntArrayElements( env,d2, NULL);

	int k,diagNo;
	jint *d0ptr = d0ptr_init;
	jint *d1ptr = d1ptr_init;
	jint *d2ptr = d2ptr_init;
	for( diagNo = 2 ; diagNo < totalDiags -2 ; ++diagNo ) {
//    		__android_log_print(
//			ANDROID_LOG_ERROR,
//			LOG_TAG, 
//			"processNativeSlow4, diagNo: %d",diagNo);
		int diagLen = 0;
		if( diagNo < minnm )
			diagLen = diagNo+1;
		else
		if( diagNo < maxnm )
			diagLen = minnm;
		else
			diagLen = totalDiags - diagNo;
		for( k = 0 ; k < diagLen ; ++k ) {
//    			__android_log_print(
//				ANDROID_LOG_ERROR,
//				LOG_TAG, 
//				"processNativeSlow5, k: %d",k);

// Starting X position of the diag is
// diag# if diag# < maxnm
// maxnm-1 if diag# >= maxmn
			int diagX = diagNo >= maxnm ? maxnm - 1 : diagNo;
// Starting Y position of the diag is
// 0 if diag# < maxnm
// diag# - maxnm + 1 if diag# >= maxnm
			int diagY = diagNo < maxnm ? 0 : diagNo - maxnm + 1;
			jint sum = 0;
			if( k == 0 && (  diagNo < maxnm ) ) {
				sum = d1ptr[0] + signalCost((jint)signal1ptr[diagNo],(jint)signal2ptr[0]);
			} else 
			if( ( k == ( diagLen - 1 ) ) && ( diagNo < minnm ) ) {
				sum = d1ptr[diagNo-1] + signalCost((jint)signal1ptr[0],(jint)signal2ptr[diagNo]);
			} else 
			if( diagNo < maxnm ) {
				jint s1 = (jint)signal1ptr[diagX-k];
				jint s2 = (jint)signal2ptr[diagY+k];
				jint cs = signalCost( s1,s2);
				sum = 
				MIN( 
					d0ptr[k-1],
					d1ptr[k-1] );
				sum = MIN( sum, d1ptr[k] );
				sum += cs;
			} else 
			if( diagNo == maxnm ) {
				jint s1 = (jint)signal1ptr[diagX-k];
				jint s2 = (jint)signal2ptr[diagY+k];
				jint cs = signalCost( s1,s2);
				sum = 
				MIN( 
					d0ptr[k],
					d1ptr[k] );
				sum = MIN( sum, d1ptr[k+1] );
				sum += cs;
			} else 
			if( diagNo > maxnm ) {
				jint s1 = (jint)signal1ptr[diagX-k];
				jint s2 = (jint)signal2ptr[diagY+k];
				jint cs = signalCost( s1,s2);
				sum = 
				MIN( 
					d0ptr[k+1],
					d1ptr[k] );
				sum = MIN( sum, d1ptr[k+1] );
				sum += cs;
			}
			d2ptr[k] = sum;
		}
	    	__android_log_print(
			ANDROID_LOG_ERROR,
			LOG_TAG, 
			"----- diagNo :%d",diagNo);
		for( k = 0 ; k < diagLen ; ++k ) {
	    		__android_log_print(
				ANDROID_LOG_ERROR,
				LOG_TAG, 
				"d2[%d]: %d",k,d2ptr[k]);
		}
		jint *tmp = d0ptr;
		d0ptr = d1ptr;
		d1ptr = d2ptr;
		d2ptr = tmp;
	}

	(*env)->ReleaseIntArrayElements( env,d0,d0ptr, 0);
	(*env)->ReleaseIntArrayElements( env,d1,d1ptr, 0);
	(*env)->ReleaseIntArrayElements( env,d2,d2ptr, 0);
	(*env)->ReleaseShortArrayElements( env,signal1,signal1ptr, 0);
	(*env)->ReleaseShortArrayElements( env,signal2,signal2ptr, 0);
}

JNIEXPORT void JNICALL Java_aexp_samplerecognizer_MainActivity_processNativeNEON( 
			JNIEnv* env,
			jobject thiz,
			jshortArray signal1,
			jshortArray signal2,
			jintArray d0,
			jintArray d1,
			jintArray d2,
			jint minnm,
			jint maxnm,
			jint totalDiags ) {
	jshort *signal1ptr = (*env)->GetShortArrayElements( env,signal1, NULL);
	jshort *signal2ptr = (*env)->GetShortArrayElements( env,signal2, NULL);
	jint *d0ptr_init = (*env)->GetIntArrayElements( env,d0, NULL);
	jint *d1ptr_init = (*env)->GetIntArrayElements( env,d1, NULL);
	jint *d2ptr_init = (*env)->GetIntArrayElements( env,d2, NULL);

	int k,diagNo;
	jint *d0ptr = d0ptr_init;
	jint *d1ptr = d1ptr_init;
	jint *d2ptr = d2ptr_init;
	for( diagNo = 2 ; diagNo < totalDiags-2 ; ++diagNo ) {
//    		__android_log_print(
//			ANDROID_LOG_ERROR,
//			LOG_TAG, 
//			"processNativeSlow4, diagNo: %d",diagNo);
		int diagLen = 0;
		if( diagNo < minnm )
			diagLen = diagNo+1;
		else
		if( diagNo < maxnm )
			diagLen = minnm;
		else
			diagLen = totalDiags - diagNo;
// Starting X position of the diag is
// diag# if diag# < maxnm
// maxnm-1 if diag# >= maxmn
		int diagX = diagNo >= maxnm ? maxnm - 1 : diagNo;
// Starting Y position of the diag is
// 0 if diag# < maxnm
// diag# - maxnm + 1 if diag# >= maxnm
		int diagY = diagNo < maxnm ? 0 : diagNo - maxnm + 1;
		int k;
		int diagLenM1 = diagLen - 1;
		if( diagNo < maxnm ) {
			d2ptr[0] = d1ptr[0] + 
				signalCost((jint)signal1ptr[diagNo],(jint)signal2ptr[0]);
			int dummy = 0;
			jint *d0ptrbase = d0ptr + 1;
			jint *d1ptrbase = d1ptr + 1;
			jint *d2ptrbase = d2ptr + 1;
			jshort *signal1base = signal1ptr + ( diagX - 1 );
			jshort *signal2base = signal2ptr + ( diagY + 1 );
			int ctr = diagLenM1-1;
//	    		__android_log_print(
//				ANDROID_LOG_ERROR,
//				LOG_TAG, 
//				"diagNo :%d",diagNo);
			asm volatile(
				"mov	r1,%[signal1base]\n\t"
				"mov	r2,%[signal2base]\n\t"
				"mov	r3,%[d0ptrbase]\n\t"
				"mov	r4,%[d1ptrbase]\n\t"
				"mov	r5,%[d2ptrbase]\n\t"
				"loop0:\n\t"
// d0_low=signal1[diagX-k]
				"LDRSH		r0,[r1,#0]\n\t"
				"VMOV		s0,r0\n\t"
// d2_low=signal2[diagY+k]
				"LDRSH		r0,[r2,#0]\n\t"
				"VMOV		s4,r0\n\t"
// d0_high=signal1[diagX-k]
				"LDRSH		r0,[r1,#-2]\n\t"
				"VMOV		s1,r0\n\t"
// d2_high=signal2[diagY+k]
				"LDRSH		r0,[r2,#2]\n\t"
				"VMOV		s5,r0\n\t"
// d1_low=signal1[diagX-k]
				"LDRSH		r0,[r1,#-4]\n\t"
				"VMOV		s2,r0\n\t"
// d3_low=signal2[diagY+k]
				"LDRSH		r0,[r2,#4]\n\t"
				"VMOV		s6,r0\n\t"
// d1_high=signal1[diagX-k]
				"LDRSH		r0,[r1,#-6]\n\t"
				"VMOV		s3,r0\n\t"
// d3_high=signal2[diagY+k]
				"LDRSH		r0,[r2,#6]\n\t"
				"VMOV		s7,r0\n\t"

// d0[k-1]->q9
				"SUB		R0,r3,#4\n\t"
				"VLD1.32	{d18,d19},[r0]\n\t"
// d1[k-1]->q10
				"SUB		R0,r4,#4\n\t"
				"VLD1.32	{d20,d21},[r0]\n\t"

// cs=abs(sig1-sig2)
				"VSUB.I32	Q3,Q0,Q1\n\t"
				"VABS.S32	Q3,Q3\n\t"

// d1[k]->q8
				"VLD1.32	{d16,d17},[r4]\n\t"

// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5) q2=min(q0,q1)
				"VMIN.U32	Q2,Q9,Q10\n\t"
// q0=(d0,d1),q2=(d4,d5),q1=(d2,d3), q1=min(q2,q0)
				"VMIN.U32	Q1,Q2,Q8\n\t"
// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5)
				"VADD.I32	Q2,Q3,Q1\n\t"
// d2[k,k+1,k+2,k+3]=q2
				"VST1.32	{d4,d5},[r5]!\n\t"
				"ADD		r3,#16\n\t"
				"ADD		r4,#16\n\t"
				"SUB		r1,#8\n\t"
				"ADD		r2,#8\n\t"
				"SUBS		%[ctr],#4\n\t"
				"bmi		loop0_end\n\t"
				"bne		loop0\n\t"
				"loop0_end:\n\t"
				:
				"=r" (dummy)
				:
				[d2ptrbase] "r" (d2ptrbase),
				[d1ptrbase] "r" (d1ptrbase),
				[d0ptrbase] "r" (d0ptrbase),
				[signal1base] "r" (signal1base),
				[signal2base] "r" (signal2base),
				[ctr] "r" (ctr)
				: "r0","r1","r2","r3","r4","r5", 					"d0","d1","d2","d3","d4","d5","d6","d7",
				"d16","d17","d18","d19","d20","d21"
			);
			if( diagNo < minnm ) {
				d2ptr[diagLenM1] = d1ptr[diagNo-1] + 
					signalCost((jint)signal1ptr[0],(jint)signal2ptr[diagNo]);
			}
		} else 
		if( diagNo == maxnm ) {
			int dummy = 0;
			jint *d0ptrbase = d0ptr;
			jint *d1ptrbase = d1ptr;
			jint *d2ptrbase = d2ptr;
			jshort *signal1base = signal1ptr + ( diagX );
			jshort *signal2base = signal2ptr + ( diagY  );
			int ctr = diagLen;
//	    		__android_log_print(
//				ANDROID_LOG_ERROR,
//				LOG_TAG, 
//				"diagNo :%d",diagNo);
			asm volatile(
				"mov	r1,%[signal1base]\n\t"
				"mov	r2,%[signal2base]\n\t"
				"mov	r3,%[d0ptrbase]\n\t"
				"mov	r4,%[d1ptrbase]\n\t"
				"mov	r5,%[d2ptrbase]\n\t"
				"loop2:\n\t"
// d0_low=signal1[diagX-k]
				"LDRSH		r0,[r1,#0]\n\t"
				"VMOV		s0,r0\n\t"
// d2_low=signal2[diagY+k]
				"LDRSH		r0,[r2,#0]\n\t"
				"VMOV		s4,r0\n\t"
// d0_high=signal1[diagX-k]
				"LDRSH		r0,[r1,#-2]\n\t"
				"VMOV		s1,r0\n\t"
// d2_high=signal2[diagY+k]
				"LDRSH		r0,[r2,#2]\n\t"
				"VMOV		s5,r0\n\t"
// d1_low=signal1[diagX-k]
				"LDRSH		r0,[r1,#-4]\n\t"
				"VMOV		s2,r0\n\t"
// d3_low=signal2[diagY+k]
				"LDRSH		r0,[r2,#4]\n\t"
				"VMOV		s6,r0\n\t"
// d1_high=signal1[diagX-k]
				"LDRSH		r0,[r1,#-6]\n\t"
				"VMOV		s3,r0\n\t"
// d3_high=signal2[diagY+k]
				"LDRSH		r0,[r2,#6]\n\t"
				"VMOV		s7,r0\n\t"

// d0[k]->q9
				"VLD1.32	{d18,d19},[r3]\n\t"
// d1[k+1]->q10
				"ADD		R0,r4,#4\n\t"
				"VLD1.32	{d20,d21},[r0]\n\t"

// cs=abs(sig1-sig2)
				"VSUB.I32	Q3,Q0,Q1\n\t"
				"VABS.S32	Q3,Q3\n\t"

// d1[k]->q8
				"VLD1.32	{d16,d17},[r4]\n\t"

// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5) q2=min(q0,q1)
				"VMIN.U32	Q2,Q9,Q10\n\t"
// q0=(d0,d1),q2=(d4,d5),q1=(d2,d3), q1=min(q2,q0)
				"VMIN.U32	Q1,Q2,Q8\n\t"
// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5)
				"VADD.I32	Q2,Q3,Q1\n\t"
// d2[k,k+1,k+2,k+3]=q2
				"VST1.32	{d4,d5},[r5]!\n\t"
				"ADD		r3,#16\n\t"
				"ADD		r4,#16\n\t"
				"SUB		r1,#8\n\t"
				"ADD		r2,#8\n\t"
				"SUBS		%[ctr],#4\n\t"
				"bmi		loop2_end\n\t"
				"bne		loop2\n\t"
				"loop2_end:\n\t"
				:
				"=r" (dummy)
				:
				[d2ptrbase] "r" (d2ptrbase),
				[d1ptrbase] "r" (d1ptrbase),
				[d0ptrbase] "r" (d0ptrbase),
				[signal1base] "r" (signal1base),
				[signal2base] "r" (signal2base),
				[ctr] "r" (ctr)
				: "r0","r1","r2","r3","r4","r5", 					"d0","d1","d2","d3","d4","d5","d6","d7",
				"d16","d17","d18","d19","d20","d21"
			);
/*
			for( k = 0 ; k < diagLen ; k += 4 ) {
				jint *d0ptrbase = d0ptr + k;
				jint *d1ptrbase = d1ptr + k;
				jint *d2ptrbase = d2ptr + k;
				jshort *signal1base = signal1ptr + ( diagX - k );
				jshort *signal2base = signal2ptr + ( diagY + k );

				asm volatile(
// d1_high=signal1[diagX-k]
				"LDRSH		r0,[%[signal1base],#0]\n\t"
				"VMOV		s3,r0\n\t"
// d3_high=signal2[diagY-k]
				"LDRSH		r0,[%[signal2base],#0]\n\t"
				"VMOV		s7,r0\n\t"
// d1_low=signal1[diagX-k]
				"LDRSH		r0,[%[signal1base],#-2]\n\t"
				"VMOV		s2,r0\n\t"
// d3_low=signal2[diagY-k]
				"LDRSH		r0,[%[signal2base],#2]\n\t"
				"VMOV		s6,r0\n\t"
// d0_high=signal1[diagX-k]
				"LDRSH		r0,[%[signal1base],#-4]\n\t"
				"VMOV		s1,r0\n\t"
// d2_high=signal2[diagY-k]
				"LDRSH		r0,[%[signal2base],#4]\n\t"
				"VMOV		s5,r0\n\t"
// d0_low=signal1[diagX-k]
				"LDRSH		r0,[%[signal1base],#-6]\n\t"
				"VMOV		s0,r0\n\t"
// d2_low=signal2[diagY-k]
				"LDRSH		r0,[%[signal2base],#6]\n\t"
				"VMOV		s4,r0\n\t"
// cs=abs(sig1-sig2)
				"VSUB.I32	Q3,Q0,Q1\n\t"
				"VABS.S32	Q3,Q3\n\t"
// d1_high=d0_0[k]
				"VLDR.32	s3,[%[d0ptrbase],#0]\n\t"
// d3_high=d1_0[k]
				"VLDR.32	s7,[%[d1ptrbase],#0]\n\t"
// d1_low=d0_1[k]
				"VLDR.32	s2,[%[d0ptrbase],#4]\n\t"
// d3_low=d1_1[k]
				"VLDR.32	s6,[%[d1ptrbase],#4]\n\t"
// d0_high=d0_2[k]
				"VLDR.32	s1,[%[d0ptrbase],#8]\n\t"
// d2_high=d1_2[k]
				"VLDR.32	s5,[%[d1ptrbase],#8]\n\t"
// d0_low=d0_3[k]
				"VLDR.32	s0,[%[d0ptrbase],#12]\n\t"
// d2_low=d1_3[k]
				"VLDR.32	s4,[%[d1ptrbase],#12]\n\t"
// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5) q2=min(q0,q1)
				"VMIN.U32	Q2,Q0,Q1\n\t"
// d1_high=d1_0[k+1]
				"VLDR.32	s3,[%[d1ptrbase],#4]\n\t"
// d1_low=d1_1[k+1]
				"VLDR.32	s2,[%[d1ptrbase],#8]\n\t"
// d0_high=d1_2[k+1]
				"VLDR.32	s1,[%[d1ptrbase],#12]\n\t"
// d0_low=d1_3[k+1]
				"VLDR.32	s0,[%[d1ptrbase],#16]\n\t"
// q0=(d0,d1),q2=(d4,d5),q1=(d2,d3), q1=min(q2,q0)
				"VMIN.U32	Q1,Q2,Q0\n\t"
// q0=(d0,d1),q3=(d6,d7),q2=(d4,d5)
				"VADD.I32	Q2,Q3,Q1\n\t"
// d2[k,k+1,k+2,k+3]=q2
//				"VSTM	%[d2ptrbase],{q2}"
				"VSTR.32	s11,[%[d2ptrbase],#0]\n\t"
				"VSTR.32	s10,[%[d2ptrbase],#4]\n\t"
				"VSTR.32	s9,[%[d2ptrbase],#8]\n\t"
				"VSTR.32	s8,[%[d2ptrbase],#12]\n\t"
				:
				"=r" (dummy)
				:
				[d2ptrbase] "r" (d2ptrbase),
				[d1ptrbase] "r" (d1ptrbase),
				[d0ptrbase] "r" (d0ptrbase),
				[signal1base] "r" (signal1base),
				[signal2base] "r" (signal2base)
				: "r0","d0","d1","d2","d3","d4","d5"
				);
			}
*/
		} else 
		if( diagNo > maxnm ) {
			int dummy = 0;
			jint *d0ptrbase = d0ptr;
			jint *d1ptrbase = d1ptr;
			jint *d2ptrbase = d2ptr;
			jshort *signal1base = signal1ptr + ( diagX );
			jshort *signal2base = signal2ptr + ( diagY  );
			int ctr = diagLen;
//	    		__android_log_print(
//				ANDROID_LOG_ERROR,
//				LOG_TAG, 
//				"diagNo :%d",diagNo);
			asm volatile(
				"mov	r1,%[signal1base]\n\t"
				"mov	r2,%[signal2base]\n\t"
				"mov	r3,%[d0ptrbase]\n\t"
				"mov	r4,%[d1ptrbase]\n\t"
				"mov	r5,%[d2ptrbase]\n\t"
				"loop1:\n\t"
// d0_low=signal1[diagX-k]
				"LDRSH		r0,[r1,#0]\n\t"
				"VMOV		s0,r0\n\t"
// d2_low=signal2[diagY+k]
				"LDRSH		r0,[r2,#0]\n\t"
				"VMOV		s4,r0\n\t"
// d0_high=signal1[diagX-k]
				"LDRSH		r0,[r1,#-2]\n\t"
				"VMOV		s1,r0\n\t"
// d2_high=signal2[diagY+k]
				"LDRSH		r0,[r2,#2]\n\t"
				"VMOV		s5,r0\n\t"
// d1_low=signal1[diagX-k]
				"LDRSH		r0,[r1,#-4]\n\t"
				"VMOV		s2,r0\n\t"
// d3_low=signal2[diagY+k]
				"LDRSH		r0,[r2,#4]\n\t"
				"VMOV		s6,r0\n\t"
// d1_high=signal1[diagX-k]
				"LDRSH		r0,[r1,#-6]\n\t"
				"VMOV		s3,r0\n\t"
// d3_high=signal2[diagY+k]
				"LDRSH		r0,[r2,#6]\n\t"
				"VMOV		s7,r0\n\t"

// d0[k+1]->q9
				"ADD		R0,r3,#4\n\t"
				"VLD1.32	{d18,d19},[r0]\n\t"
// d1[k+1]->q10
				"ADD		R0,r4,#4\n\t"
				"VLD1.32	{d20,d21},[r0]\n\t"

// cs=abs(sig1-sig2)
				"VSUB.I32	Q3,Q0,Q1\n\t"
				"VABS.S32	Q3,Q3\n\t"

// d1[k]->q8
				"VLD1.32	{d16,d17},[r4]\n\t"

// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5) q2=min(q0,q1)
				"VMIN.U32	Q2,Q9,Q10\n\t"
// q0=(d0,d1),q2=(d4,d5),q1=(d2,d3), q1=min(q2,q0)
				"VMIN.U32	Q1,Q2,Q8\n\t"
// q0=(d0,d1),q1=(d2,d3),q2=(d4,d5)
				"VADD.I32	Q2,Q3,Q1\n\t"
// d2[k,k+1,k+2,k+3]=q2
				"VST1.32	{d4,d5},[r5]!\n\t"
				"ADD		r3,#16\n\t"
				"ADD		r4,#16\n\t"
				"SUB		r1,#8\n\t"
				"ADD		r2,#8\n\t"
				"SUBS		%[ctr],#4\n\t"
				"bmi		loop1_end\n\t"
				"bne		loop1\n\t"
				"loop1_end:\n\t"
				:
				"=r" (dummy)
				:
				[d2ptrbase] "r" (d2ptrbase),
				[d1ptrbase] "r" (d1ptrbase),
				[d0ptrbase] "r" (d0ptrbase),
				[signal1base] "r" (signal1base),
				[signal2base] "r" (signal2base),
				[ctr] "r" (ctr)
				: "r0","r1","r2","r3","r4","r5", 					"d0","d1","d2","d3","d4","d5","d6","d7",
				"d16","d17","d18","d19","d20","d21"
			);
		}
/*
	    	__android_log_print(
			ANDROID_LOG_ERROR,
			LOG_TAG, 
			"----- diagNo :%d",diagNo);
		for( k = 0 ; k < diagLen ; ++k ) {
	    		__android_log_print(
				ANDROID_LOG_ERROR,
				LOG_TAG, 
				"d2[%d]: %d",k,d2ptr[k]);
		}
*/
 		jint *tmp = d0ptr;
		d0ptr = d1ptr;
		d1ptr = d2ptr;
		d2ptr = tmp;
	}
	(*env)->ReleaseIntArrayElements( env,d0,d0ptr, 0);
	(*env)->ReleaseIntArrayElements( env,d1,d1ptr, 0);
	(*env)->ReleaseIntArrayElements( env,d2,d2ptr, 0);
	(*env)->ReleaseShortArrayElements( env,signal1,signal1ptr, 0);
	(*env)->ReleaseShortArrayElements( env,signal2,signal2ptr, 0);
}

