#pragma version(1)
#pragma rs java_package_name(aexp.samplerecognizer)
#define signalCost(x1,x2) ( (x1) > (x2) ? ( x1 - x2 ) : ( x2 - x1 ) )
#define int32_min(x1,x2) ((x1) > (x2) ? (x2) : (x1))
#define DIAGLEN 0
#define	DIAGX 1
#define DIAGY 2
#define	DIAGNO 3
#define DPERMUTATIONINDEX 4


int32_t s1len = 0;
int32_t s2len = 0;
int32_t *d0a;
int32_t *d1a;
int32_t *d2a;
int32_t *parms;
int16_t *signal1;
int16_t *signal2;
int32_t minnm = 0;
int32_t maxnm = 0;

int32_t __attribute__((kernel)) dtw(int32_t in, uint32_t x) {
	int32_t m = 0;
	int32_t *d0;
	int32_t *d1;
	int32_t *d2;
	switch( parms[DPERMUTATIONINDEX] ) {
		case 0:
			d0 = d0a;
			d1 = d1a;
			d2 = d2a;
			break;
			
		case 1:
			d0 = d1a;
			d1 = d2a;
			d2 = d0a;
			break;
			
		case 2:
			d0 = d2a;
			d1 = d0a;
			d2 = d1a;
			break;
	}
	int diagNo = parms[DIAGNO];
	int diagLen = parms[DIAGLEN];
	int diagX = parms[DIAGX];
	int diagY = parms[DIAGY];
	if( x == 0 && (  diagNo < maxnm ) ) {
		m = d1[0] + signalCost((int32_t)signal1[diagNo],(int32_t)signal2[0]);
	} else 
	if( ( x == ( diagLen - 1 ) ) && ( diagNo < minnm ) ) {
		m = d1[diagNo-1] + signalCost((int32_t)signal1[0],(int32_t)signal2[diagNo]);
	} else 
	if( diagNo < maxnm ) {
		int s1 = signal1[diagX-x];
		int s2 = signal2[diagY+x];
		int cs = signalCost( s1,s2);
		m = 
			int32_min( 
						d0[x-1],
						d1[x-1] );
		m = int32_min( m, d1[x] );
		m += cs;
	} else 
	if( diagNo == maxnm ) {
		int s1 = signal1[diagX-x];
		int s2 = signal2[diagY+x];
		int cs = signalCost( s1,s2);
		m = 
			int32_min( 
						d0[x],
						d1[x] );
		m = int32_min( m, d1[x+1] );
		m += cs;
	} else 
	if( diagNo > maxnm ) {
		int s1 = signal1[diagX-x];
		int s2 = signal2[diagY+x];
		int cs = signalCost( s1,s2);
		m = 
			int32_min( 
						d0[x+1],
						d1[x] );
		m = int32_min( m, d1[x+1] );
		m += cs;
	}
	return m;
}
