#pragma version(1)
#pragma rs java_package_name(aexp.samplerecognizer)
#define PARALLEL_LIMIT 5000
#define signalCost(x1,x2) ( (x1) > (x2) ? ( x1 - x2 ) : ( x2 - x1 ) )
#define int32_min(x1,x2) ((x1) > (x2) ? (x2) : (x1))
#define int32_max(x1,x2) ((x1) > (x2) ? (x1) : (x2))

rs_script s;
int32_t n = 0;
int32_t m = 0;
int32_t *d0a;
int32_t *d1a;
int32_t *d2a;
int32_t *d0;
int32_t *d1;
int32_t *d2;
int16_t *signal1;
int16_t *signal2;
int32_t diagLen = 0;
int32_t diagX = 0;
int32_t diagY = 0;
int32_t diagNo = 0;
int32_t minnm = 0;
int32_t maxnm = 0;

void root(int *out, uint32_t x) {
	int m = 0;
	if( x == 0 && ( diagNo < maxnm ) ) {
		m = d1[0] + signalCost((int32_t)signal1[diagNo],(int32_t)signal2[0]);
	} else 
	if( ( x == ( diagLen - 1 ) ) && ( diagNo < minnm ) ) {
		m = d1[diagNo-1] + signalCost((int32_t)signal1[0],(int32_t)signal2[diagNo]);
	} else 
	if( diagNo < maxnm ) {
		int s1 = signal1[diagX-x];
		int s2 = signal2[diagY+x];
		int cs = signalCost( s1,s2);
		m = 
			int32_min( 
						d0[x-1],
						d1[x-1] );
		m = int32_min( m, d1[x] );
		m += cs;
	} else 
	if( diagNo == maxnm ) {
		int s1 = signal1[diagX-x];
		int s2 = signal2[diagY+x];
		int cs = signalCost( s1,s2);
		m = 
			int32_min( 
						d0[x],
						d1[x] );
		m = int32_min( m, d1[x+1] );
		m += cs;
	} else 
	if( diagNo > maxnm ) {
		int s1 = signal1[diagX-x];
		int s2 = signal2[diagY+x];
		int cs = signalCost( s1,s2);
		m = 
			int32_min( 
						d0[x+1],
						d1[x] );
		m = int32_min( m, d1[x+1] );
		m += cs;
	}
	*out = m;
}

void dtw() {
		d0 = d0a;
		d1 = d1a;
		d2 = d2a;
		int totalDiags = n+m-1;
		minnm = int32_min(n,m);
		maxnm = int32_max(n,m);
    	rs_script_call_t rssc = {0};
    	rssc.strategy = RS_FOR_EACH_STRATEGY_DONT_CARE;
		for( int i = 2 ; i < totalDiags - 2 ; ++i ) {
			diagNo = i;
// The length of the diag is the following:
// i+1 if diag# < minnm
// minnm if diag# >= minnm and diag# < maxnm
// totalDiags-diag# if diag# > maxnm
			diagLen = 0;
			if( i < minnm )
				diagLen = i+1;
			else
			if( i < maxnm )
				diagLen = minnm;
			else
				diagLen = totalDiags - i;
// Starting X position of the diag is
// diag# if diag# < maxnm
// maxnm-1 if diag# >= maxmn
			diagX = i >= maxnm ? maxnm - 1 : i;
// Starting Y position of the diag is
// 0 if diag# < maxnm
// diag# - maxnm + 1 if diag# >= maxnm
			diagY = i < maxnm ? 0 : i - maxnm + 1;
			if( diagLen < PARALLEL_LIMIT ) {
				int *dp = d2;
				for( int k = 0 ; k < diagLen ; ++k ) {
					root( dp,k );
					++dp;
				}
			} else {
    			rssc.xStart = 0;
    			rssc.xEnd = diagLen;
    			rs_allocation d1alloc = rsGetAllocation( d1 );
    			rs_allocation d2alloc = rsGetAllocation( d2 );
    			rsForEach( s,d1alloc,d2alloc,NULL,0,&rssc);
    		}
			int* tmp = d0;
			d0 = d1;
			d1 = d2;
			d2 = tmp;
		}

}

